sfcode An Online Competing and Development Environment

README

english | русский

## SVGO <a href="https://npmjs.org/package/svgo"><img src="https://badge.fury.io/js/svgo.svg" alt="NPM version"/></a> <a href="https://travis-ci.org/svg/svgo"><img src="https://secure.travis-ci.org/svg/svgo.svg" alt="Build Status"/></a> <a href="https://coveralls.io/r/svg/svgo?branch=master"><img src="https://img.shields.io/coveralls/svg/svgo.svg" alt="Coverage Status"/></a>

**SVG O**ptimizer is a Nodejs-based tool for optimizing SVG vector graphics files.

## Why?

SVG files, especially those exported from various editors, usually contain a lot of redundant and useless information. This can include editor metadata, comments, hidden elements, default or non-optimal values and other stuff that can be safely removed or converted without affecting the SVG rendering result.

## What it can do

SVGO has a plugin-based architecture, so almost every optimization is a separate plugin.

Today we have:

Plugin | Description | Default
--- | --- | ---
cleanupAttrs | cleanup attributes from newlines, trailing, and repeating spaces | `enabled`
inlineStyles | move and merge styles from `<style>` elements to element `style` attributes | `enabled`
removeDoctype | remove doctype declaration | `enabled`
removeXMLProcInst | remove XML processing instructions | `enabled`
removeComments | remove comments | `enabled`
removeMetadata | remove `<metadata>` | `enabled`
removeTitle | remove `<title>` | `enabled`
removeDesc | remove `<desc>` | `enabled`
removeUselessDefs | remove elements of `<defs>` without `id` | `enabled`
removeXMLNS | removes `xmlns` attribute (for inline svg) | `disabled`
removeEditorsNSData | remove editors namespaces, elements, and attributes | `enabled`
removeEmptyAttrs | remove empty attributes | `enabled`
removeHiddenElems | remove hidden elements | `enabled`
removeEmptyText | remove empty Text elements | `enabled`
removeEmptyContainers | remove empty Container elements | `enabled`
removeViewBox | remove `viewBox` attribute when possible | `enabled`
cleanupEnableBackground | remove or cleanup `enable-background` attribute when possible | `enabled`
minifyStyles | minify `<style>` elements content with CSSO | `enabled`
convertStyleToAttrs | convert styles into attributes | `enabled`
convertColors | convert colors (from `rgb()` to `#rrggbb`, from `#rrggbb` to `#rgb`) | `enabled`
convertPathData | convert Path data to relative or absolute (whichever is shorter), convert one segment to another, trim useless delimiters, smart rounding, and much more | `enabled`
convertTransform | collapse multiple transforms into one, convert matrices to the short aliases, and much more | `enabled`
removeUnknownsAndDefaults | remove unknown elements content and attributes, remove attrs with default values | `enabled`
removeNonInheritableGroupAttrs | remove non-inheritable group's "presentation" attributes | `enabled`
removeUselessStrokeAndFill | remove useless `stroke` and `fill` attrs | `enabled`
removeUnusedNS | remove unused namespaces declaration | `enabled`
prefixIds | prefix IDs and classes with the SVG filename or an arbitrary string | `disabled`
cleanupIDs | remove unused and minify used IDs | `enabled`
cleanupNumericValues | round numeric values to the fixed precision, remove default `px` units | `enabled`
cleanupListOfValues | round numeric values in attributes that take a list of numbers (like `viewBox` or `enable-background`) | `disabled`
moveElemsAttrsToGroup | move elements' attributes to their enclosing group | `enabled`
moveGroupAttrsToElems | move some group attributes to the contained elements | `enabled`
collapseGroups | collapse useless groups | `enabled`
removeRasterImages | remove raster images | `disabled`
mergePaths | merge multiple Paths into one | `enabled`
convertShapeToPath | convert some basic shapes to `<path>` | `enabled`
convertEllipseToCircle | convert non-eccentric `<ellipse>` to `<circle>` | `enabled`
sortAttrs | sort element attributes for epic readability | `disabled`
sortDefsChildren | sort children of `<defs>` in order to improve compression | `enabled`
removeDimensions | remove `width`/`height` and add `viewBox` if it's missing (opposite to removeViewBox, disable it first) | `disabled`
removeAttrs | remove attributes by pattern | `disabled`
removeAttributesBySelector | removes attributes of elements that match a css selector | `disabled`
removeElementsByAttr | remove arbitrary elements by ID or className | `disabled`
addClassesToSVGElement | add classnames to an outer `<svg>` element | `disabled`
addAttributesToSVGElement | adds attributes to an outer `<svg>` element | `disabled`
removeOffCanvasPaths | removes elements that are drawn outside of the viewbox | `disabled`
removeStyleElement | remove `<style>` elements | `disabled`
removeScriptElement | remove `<script>` elements | `disabled`
reusePaths | Find duplicated <path> elements and replace them with <use> links | `disabled`

Want to know how it works and how to write your own plugin? Of course you want to. (동작방법)

## Installation

$ [sudo] npm install -g svgo

## Usage

### <abbr title="Command Line Interface">CLI</abbr>

Usage:
svgo [OPTIONS] [ARGS]
Options:
-h, --help : Help
-v, --version : Version
-i INPUT, --input=INPUT : Input file, "-" for STDIN
-s STRING, --string=STRING : Input SVG data string
-f FOLDER, --folder=FOLDER : Input folder, optimize and rewrite all *.svg files
-o OUTPUT, --output=OUTPUT : Output file or folder (by default the same as the input), "-" for STDOUT
-p PRECISION, --precision=PRECISION : Set number of digits in the fractional part, overrides plugins params
--config=CONFIG : Config file or JSON string to extend or replace default
--disable=PLUGIN : Disable plugin by name, "--disable=PLUGIN1,PLUGIN2" for multiple plugins
--enable=PLUGIN : Enable plugin by name, "--enable=PLUGIN3,PLUGIN4" for multiple plugins
--datauri=DATAURI : Output as Data URI string (base64, URI encoded or unencoded)
--multipass : Pass over SVGs multiple times to ensure all optimizations are applied
--pretty : Make SVG pretty printed
--indent=INDENT : Indent number when pretty printing SVGs
-r, --recursive : Use with '-f'. Optimizes *.svg files in folders recursively.
-q, --quiet : Only output error messages, not regular status messages
--show-plugins : Show available plugins and exit
Arguments:
INPUT : Alias to --input

- with files:

  ```sh $ svgo test.svg ```

  or:

  ```sh $ svgo *.svg ```

  ```sh $ svgo test.svg -o test.min.svg ```

  ```sh $ svgo test.svg other.svg third.svg ```

  ```sh $ svgo test.svg other.svg third.svg -o test.min.svg -o other.min.svg -o third.min.svg ```

- with STDIN / STDOUT:

  ```sh $ cat test.svg | svgo -i - -o - > test.min.svg ```

- with folder

  ```sh $ svgo -f ../path/to/folder/with/svg/files ```

  or:

  ```sh $ svgo -f ../path/to/folder/with/svg/files -o ../path/to/folder/with/svg/output ```

  ```sh $ svgo *.svg -o ../path/to/folder/with/svg/output ```

- with strings:

  ``‘sh $ svgo -s ’<svg version="1.1">test</svg>' -o test.min.svg ```

  or even with Data URI base64:

  ``‘sh $ svgo -s 'data:image/svg+xml;base64,...’ -o test.min.svg ```

- with SVGZ:

  from `.svgz` to `.svg`:

  ```sh $ gunzip -c test.svgz | svgo -i - -o test.min.svg ```

  from `.svg` to `.svgz`:

  ```sh $ svgo test.svg -o - | gzip -cfq9 > test.svgz ```

### Other Ways to Use SVGO

- as a web app – SVGOMG
- as a Nodejs module – examples
- as a Grunt task – grunt-svgmin
- as a Gulp task – gulp-svgmin
- as a Mimosa module – mimosa-minify-svg
- as an OSX Folder Action – svgo-osx-folder-action
- as a webpack loader – image-webpack-loader
- as a Telegram Bot – svgo_bot
- as a PostCSS plugin – postcss-svgo
- as an Inkscape plugin – inkscape-svgo
- as a Sketch plugin - svgo-compressor
- as macOS app - Image Shrinker
- as a Rollup plugin - rollup-plugin-svgo

## Backers

SheetJS LLC | Fontello

## Donations

- PayPal: https://www.paypal.me/deepsweet

## License and Copyright

This software is released under the terms of the MIT license.

Logo by Yegor Bolshakov.